# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define serverrepodir %{_javadir}/repository.jboss.com/jboss/jnpserver/%{namedversion}-brew
%define serverrepodirlib %{serverrepodir}/lib
%define serverrepodirsrc %{serverrepodir}/src
%define clientrepodir %{_javadir}/repository.jboss.com/jboss/jnp-client/%{namedversion}-brew
%define clientrepodirlib %{clientrepodir}/lib
%define clientrepodirsrc %{clientrepodir}/src

# use pre-build jboss-test jar in bootstrap mode
%bcond_without bootstrap

%define section free
%define reltag CP01
%global namedversion %{version}.GA_CP01

Name:           jboss-naming
Version:        5.0.3
Release:        3.%{reltag}.3.1%{?dist}
Epoch:          0
Summary:        JBoss Naming
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn export https://svn.jboss.org/repos/jbossas/projects/naming/tags/5.0.3.GA_CP01 jboss-naming-5.0.3
# Exported revision 112100
# tar czf jboss-naming-5.0.3.CP01.tar.gz jboss-naming-5.0.3
Source0:        jboss-naming-5.0.3.%{reltag}.tar.gz
Source1:        jboss-naming-jpp-depmap.xml
Source2:        jboss-naming-settings.xml
Source4:        jboss-naming-jnpserver-component-info.xml
Source5:        jboss-naming-jnp-client-component-info.xml

%if %with bootstrap
Source6:        jboss-test-1.1.4.jar
%endif
Patch0:         jboss-naming-build.patch
BuildArch:      noarch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
Requires:  java >= 0:1.5.0
Requires:  jboss-common-core
Requires:  jboss-common-logging-spi
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-release
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  mojo-maven2-plugin-rmic
BuildRequires:  jboss-microcontainer2
BuildRequires:  jboss-parent
#BuildRequires:  jboss-test
BuildRequires:  ant-junit
BuildRequires:  junit
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires:  jboss-common-core
BuildRequires:  jboss-common-logging-spi


%description
JBoss Naming.

%if %with repolib
%package server-repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description     server-repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.

%package         client-repolib
Summary:         Artifacts to be uploaded to a repository library
Group:  Development/Libraries/Java

%description     client-repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%prep
%setup -q 
%patch0 -p1 -b .sav0
mkdir -p jnpclient/src/main/java
touch jnpclient/src/main/java/No.java

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
mkdir -p $MAVEN_REPO_LOCAL/org.jboss.jbossas/
# FIXME: (dwalluck): shoud depend on external package
ln -s $MAVEN_REPO_LOCAL/org/jboss/jbossas/jboss-as-j2se/%{namedversion}/jboss-as-j2se-%{namedversion}-tests.jar $MAVEN_REPO_LOCAL/org.jboss.jbossas/jboss-as-j2se-tests.jar

%if %with bootstrap
mkdir -p ${MAVEN_REPO_LOCAL}/org/jboss/test/jboss-test/1.1.1.GA
cp -pr %{SOURCE4} ${MAVEN_REPO_LOCAL}/org/jboss/test/jboss-test/1.1.1.GA/jboss-test-1.1.1.GA.jar
%endif

%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.test.skip=true \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        install 

%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Daggregate=true \
        -Dmaven.test.skip=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        javadoc:javadoc 

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 jnpclient/target/jnp-client-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jnp-client-%{version}.jar
install -m 644 jnpclient/target/jnp-client-%{namedversion}-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jnp-client-%{version}-sources.jar
install -m 644 jnpserver/target/jnpserver-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jnpserver-%{version}.jar
install -m 644 jnpserver/target/jnpserver-%{namedversion}-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jnpserver-%{version}-sources.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
%add_to_maven_depmap org.jboss.naming jboss-naming-build %{namedversion} JPP/%{name} build
%add_to_maven_depmap org.jboss.naming jnpserver %{namedversion} JPP/%{name} jnpserver
%add_to_maven_depmap org.jboss.naming jnp-client %{namedversion} JPP/%{name} jnp-client
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-build.pom
install -m 644 jnpclient/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jnp-client.pom
install -m 644 jnpserver/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jnpserver.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -rf target/site/apidocs/* \
                  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %with repolib
install -d -m 755 $RPM_BUILD_ROOT%{serverrepodir}
install -d -m 755 $RPM_BUILD_ROOT%{serverrepodirlib}
install -d -m 755 $RPM_BUILD_ROOT%{serverrepodirsrc}
install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{serverrepodirsrc}
install -p -m 644 %{SOURCE4} $RPM_BUILD_ROOT%{serverrepodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{serverrepodir}/component-info.xml
sed -i "s/@VERSION@/%{namedversion}-brew/g" $RPM_BUILD_ROOT%{serverrepodir}/component-info.xml
install -p -m 644 $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jnpserver.pom $RPM_BUILD_ROOT%{serverrepodirlib}/jnpserver.pom
install -p -m 644 $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-build.pom $RPM_BUILD_ROOT%{serverrepodirlib}/jboss-naming-build.pom
install -p -m 644 $RPM_BUILD_ROOT%{_javadir}/%{name}/jnpserver-%{version}.jar $RPM_BUILD_ROOT%{serverrepodirlib}/jnpserver.jar
install -p -m 644 $RPM_BUILD_ROOT%{_javadir}/%{name}/jnpserver-%{version}-sources.jar $RPM_BUILD_ROOT%{serverrepodirlib}/jnpserver-sources.jar

install -d -m 755 $RPM_BUILD_ROOT%{clientrepodir}
install -d -m 755 $RPM_BUILD_ROOT%{clientrepodirlib}
install -d -m 755 $RPM_BUILD_ROOT%{clientrepodirsrc}
install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{clientrepodirsrc}
install -p -m 644 %{SOURCE5} $RPM_BUILD_ROOT%{clientrepodir}/component-info.xml
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{clientrepodir}/component-info.xml
sed -i "s/@VERSION@/%{namedversion}-brew/g" $RPM_BUILD_ROOT%{clientrepodir}/component-info.xml
install -p -m 644 $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jnp-client.pom $RPM_BUILD_ROOT%{clientrepodirlib}/jnp-client.pom
install -p -m 644 $RPM_BUILD_ROOT%{_javadir}/%{name}/jnp-client-%{version}.jar $RPM_BUILD_ROOT%{clientrepodirlib}/jnp-client.jar
install -p -m 644 $RPM_BUILD_ROOT%{_javadir}/%{name}/jnp-client-%{version}-sources.jar $RPM_BUILD_ROOT%{clientrepodirlib}/jnp-client-sources.jar
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%exclude %dir %{_javadocdir}/%{name}
%{_javadir}/%{name}/jnp-client-%{version}.jar
%{_javadir}/%{name}/jnp-client.jar
%{_javadir}/%{name}/jnp-client-%{version}-sources.jar
%{_javadir}/%{name}/jnp-client-sources.jar
%{_javadir}/%{name}/jnpserver-%{version}.jar
%{_javadir}/%{name}/jnpserver.jar
%{_javadir}/%{name}/jnpserver-%{version}-sources.jar
%{_javadir}/%{name}/jnpserver-sources.jar
%{_datadir}/maven2/poms/JPP.jboss-naming-build.pom
%{_datadir}/maven2/poms/JPP.jboss-naming-jnp-client.pom
%{_datadir}/maven2/poms/JPP.jboss-naming-jnpserver.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files server-repolib
%defattr(0644,root,root,0755)
%{_javadir}/repository.jboss.com/jboss/jnpserver/

%files client-repolib
%defattr(0644,root,root,0755)
%{_javadir}/repository.jboss.com/jboss/jnp-client
%endif

%changelog
* Mon Oct 03 2011 Martha Benitez <mbenitez@redhat.com> - 0:5.0.3-3.CP01.3.1
- Rename src tar ball to include full version

* Mon Aug 29 2011 Dustin Kut Moy Cheung <dcheung@redhat.com> 0:5.0.3-3.CP01.3
- Rebuild
- Included jboss-naming-build.patch

* Fri Aug 26 2011 Dustin Kut Moy Cheung <dcheung@redhat.com> 0:5.0.3-3.CP01.2
- Rebuild
- Fixed repolib issue -- added %bcond_without repolib at the top of the spec file

* Mon Aug 22 2011 Dustin Kut Moy Cheung <dcheung@redhat.com> 0:5.0.3-3.CP01.1
- Rebuild

* Mon Aug 22 2011 Dustin Kut Moy Cheung <dcheung@redhat.com> 0:5.0.3-2.8
- Upgrade to 5.0.3.GA_CP01

* Fri May 06 2011 David Walluck <dwalluck@redhat.com> 0:5.0.3-2.7
- change maven BuildRequires to be backwards compatible
- fix repolib option definition
- fix defines to be global
- own unowned directories
- always include jboss-test jar in src.rpm
- use javadoc:aggregate
- use full version in jar and directory names

* Thu Mar 24 2011 Fernando Nasser <fnasser@redhat.com> - 0:5.0.3-2.6
- Fix versions of jboss-parent in POMs

* Tue Dec 07 2010 Martha Benitez <mbenitez@redhat.com> - 0:5.0.3-2.4
- Consolidate repolib in one package

* Tue Dec 07 2010 Martha Benitez <mbenitez@redhat.com> - 0:5.0.3-2.3.1
- Rebuild

* Tue Dec 07 2010 Martha Benitez <mbenitez@redhat.com> - 0:5.0.3-2.3
- Build with maven 2.2.1
- Change BR maven-release to maven-release-plugin
- Add BR maven-deploy-plugin, maven-site-plugin

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:5.0.3-2.2.1
- rebuilt

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.4.6-1.5
- Rebuild
- Fix depmap entry for dtdparser 

* Mon Jan 18 2010 Yong Yang <pcheung@redhat.com> 0:5.0.3-2.1.1
- Comment jboss-test, use pre-built jboss-test jar instead, rebuild if jboss-test is ready in RHEL-5-EP-5
- Set maven.test.skip=true

* Tue Aug 18 2009 Permaine Cheung <pcheung@redhat.com> 0:5.0.3-2.1
- Add repolib subpackages
- Add -sources.jar

* Mon Jun 29 2009 David Walluck <dwalluck@redhat.com> 0:5.0.3-2
- build for JPP-6

* Tue Jun 22 2009 Ralph Apel <r.apel@r-apel.de> - 0:5.0.3-1.jpp5
- first release

